import java.util.random*;

/**
 * Ten program demonstruje techniki konstrukcji obiektów.
 * @version 1.02 2018-04-10
 * @author Cay Horstmann
 */
public class ConstructorTest
{
   public static void main(String[] args)
   {
      // Wstawienie do tablic staff trzech obiektów klasy Employee.
      var staff = new Employee[3];

      staff[0] = new Employee("Hubert", 40000);
      staff[1] = new Employee(60000);
      staff[2] = new Employee();

      // Wydruk informacji o wszystkich obiektach klasy Employee.
      for (Employee e : staff)
         System.out.println("name=" + e.getName() + ",id=" + e.getId() + ",salary="
               + e.getSalary());
   }
}

class Employee
{
   private static int nextId;

   private int id;
   private String name = "";   // Inicjalizacja zmiennej składowej obiektu.
   private double salary;

   private static RandomGenerator generator = RandomGenerator.getDefault();

   // Statyczny blok inicjujący.
   static
   {
      // Ustawienie zmiennej nextId na losową liczbę całkowitą z przedziału 0 – 9999.
      nextId = generator.nextInt(10000);
   }

   // Blok inicjujący obiektów.
   {
      id = nextId;
      nextId++;
   }

   // Trzy konstruktory przeciążone.
   public Employee(String n, double s)
   {
      name = n;
      salary = s;
   }

   public Employee(double s)
   {
      // Wywołanie konstruktora Employee(String, double).
      this("Employee #" + nextId, s);
   }

   // Konstruktor domyślny.
   public Employee()
   {
      // Zmienna name zainicjalizowana wartością "" — patrz niżej.
      // Zmienna salary nie jest jawnie ustawiona — inicjalizacja wartością 0.
      // Zmienna id jest inicjalizowana w bloku inicjującym.
   }

   public String getName()
   {
      return name;
   }

   public double getSalary()
   {
      return salary;
   }

   public int getId()
   {
      return id;
   }
}